/********************************************************************** 
 Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
***********************************************************************/
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>	// for exit()

#include "log.h"

int log_level;
bool log_active;
FSSpec log_file;

/**************************************************************************/
void log_init(FSSpec filename, bool loging)
{
  log_level=LOG_NORMAL;
  log_active=loging;
  log_file=filename;
/*  freelog(LOG_NORMAL, "log started");*/
}

/**************************************************************************/
void log_set_level(int level)
{
  log_level=level;
}

/**************************************************************************/
int freelog(int level, char *message, ...)
{	// I had problems understanding the buffer code, so I removed it
	// curently, the code just writes the log message to the file.--awb
  if(level<=log_level && log_active) {
    va_list args;
    short fs;
    OSErr err;
    long count=strlen(message);
    
    err=FSpOpenDF(&log_file, fsWrPerm, &fs);
    if(err != 0)
    {
      fprintf(stderr, "couldn't open logfile: %s\n", log_file.name);
	  exit(1);
    }
    
    err=SetFPos(fs, fsFromLEOF, 0);
    if(err != 0)
    {
      fprintf(stderr, "couldn't move logfile (%s) marker position for appending.\n", log_file.name);
	  exit(1);
    }
    
    err=FSWrite(fs, &count, message);
    if(err != 0)
    {
      fprintf(stderr, "error writing logfile (%s)\n", log_file.name);
	  exit(1);
    }    
    if(count != strlen(message))
    {
      fprintf(stderr, "incomplete write to logfile (%s)\n", log_file.name);
	  exit(1);
	}
  }
  return true;
}
