// This section comes from the Open Transport SDK, specifically OTUdpPitchByNameSample.cp
// The cod was modified for this program

#include "OTSDK.h"
#include <OpenTransport.h>
#include <OpenTptInternet.h>


pascal void EventHandler(void*, OTEventCode event, OTResult result,
							   void* cookie)
{
	if (event == T_BINDCOMPLETE)
	{
		gBindCompleted = 1;
	}
	else if (event == T_OPENCOMPLETE)
	{
		gErr = (OSErr) result;
		gCookie = (TEndpoint*) cookie;
		gCode = event;
	}
	return;
}

OSErr DoUDPStaticBind(TEndpoint* ep)
{
	TBind req, ret;
	OSErr err=0;

	// bind udp to current address and port
	req.addr.len = sizeof(struct InetAddress);
	req.addr.buf = (unsigned char *) &reqsin;
	req.qlen = 1;										// don't care for udp
	ret.addr.maxlen = sizeof(struct InetAddress);
	ret.addr.buf = (unsigned char *) &retsin;

	err = ep->Bind(&req, &ret);
	if ( err != kOTNoError )
	{
		perror("OT: Static Bind returns %d\n", err);
		return err;
	}
	while (gBindCompleted == 0)
	{
	}
	gBindCompleted = 0;
	return ( err != kOTNoError );
}


OSErr DoUDPSend(TEndpoint* ep, char * data)
{
	OSErr		err;
	OTResult 	res;
	TUnitData	unitdata;

	// Send a UDP datagram

	unitdata.addr.len = sizeof(OTAddressType) + strlen(hisAddr->fName);
	unitdata.addr.buf = (UInt8*)hisAddr;
	unitdata.opt.len = 0;
	unitdata.opt.buf = 0;
	unitdata.udata.len = strlen(data);
	unitdata.udata.buf = (unsigned char *) data;
	
	err = ep->SndUData( &unitdata);

	return err;
}
