/*
 * This bit sends "I'm here" packages to the metaserver.
 */
#include <stdio.h>
#include <string.h>
//	replace POSIX includes with OT includes
//	POSIX incluides
//#include <sys/types.h>
//#include <sys/socket.h>
//#include <netinet/in.h>
//#include <arpa/inet.h>
//#include <netdb.h>
//	OT includes
#include <OpenTransport.h>
#include <OpenTptInternet.h>
//	end OT/POSIX
#include <time.h>
#include <unistd.h>
#include "meta.h"
#include "packets.h"
#include "OTSDK.h"

#ifndef INADDR_NONE
#define INADDR_NONE     0xffffffff
#endif

TEndpoint MSep;

int send_to_metaserver(char *desc, char *info)
{
	if (MSep)
	{
		err = DoSend(MSep,strcat(desc,info));
		if ( err != kOTNoError )
		{
			perror("Metaserver: DoSend() returned %d\n", err);
			exit(1);
		}
		return 1;
	}
	else
	{
		return 0;
	}
}
void server_close_udp(void)
{
	if (MSep)
	{
		//
		// Try to Unbind
		// 
		err = MSep->Unbind();
		if ( err != kOTNoError )
		{
			perror("Metaserver: Unbind() returned %d\n", err);
			exit(1);
		}
		//
		// Remove notifier
		//
		MSep->RemoveNotifier();
		//
		// Get rid of endpoint.
		//
		err = MSep->Close();
		if ( err != kOTNoError )
		{
			perror("Metaserver: CloseEndpoint() failed with %d\n", err);
			exit(1);
		}
	}
}

void server_open_udp(void)		// rewriten for OT, used OTUdpPitchByNameSample.cp for ideas (from OT SDK) for ideas-awb
{
	MSep=0

	gMSPitchPort=METASERVER_PORT;	// I decided to use the Metaserver catch port as my pitch port	
	OTInitInetAddress(&reqsin, gMSPitchPort, (InetHost) 0);
	
	hisAddr->fName=strncat(strncat(METASERVER_ADDR,':'),METASERVER_PORT);
	hisAddr->fAddressType = AF_DNS;
	//
	// Now create a UDP
	//
	gCode = 0;
	gCookie = NULL;
	gErr = 0;
	err = OTAsyncOpenEndpoint(OTCreateConfiguration(kUDPName), 0, &info, EventHandler, 0);
	if ( err == kOTNoError )
	{
		while ( gCode == 0 )
			OTIdle();
		err = gErr;
	}
	if ( err != kOTNoError )
	{
		MSep = NULL;
		perror("Metaserver: OpenEndpoint(\"UDP\") failed with %d\n", err);
	}
	else
	{
		MSep = gCookie;
	}
#ifdef O		
	//
	// Install notifier we're going to use for testing
	//
	err = MSep->InstallNotifier(&EventHandler, 0);
	if ( err != kOTNoError )
	{
		perror("Metaserver: InstallNotifier() failed with %d\n", err);
		exit(1);
	}
#endif
	//
	// Try to bind
	// 
	MSep->SetAsynchronous();
	err = DoUDPStaticBind(MSep);
	if ( err != kOTNoError )
		exit(1);		

	MSep->SetSynchronous();
}